diff --git a/src/decode.c b/src/decode.c
index 2b3679a..762c93a 100644
--- a/src/decode.c
+++ b/src/decode.c
@@ -57,6 +57,8 @@
 #include "mempool.h"
 #include "spp_normalize.h"
 #include "sfdaq.h"
+#include "sfutil/adler32.h"
+#include "sfutil/crc32.h"
 
 extern tSfActionQueueId decoderActionQ;
 extern MemPool decoderAlertMemPool;
@@ -272,6 +274,16 @@ static inline void execIcmpChksmDrop (void *data)
     }
 }
 
+static inline void execSctpChksmDrop (void *data)
+{
+    if( ScInlineMode() && ScSctpChecksumDrops() )
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_DECODE,
+            "Dropping bad packet (SCTP checksum)\n"););
+        Active_DropPacket();
+    }
+}
+
 void execDecoderEvent(void *data)
 {
     MemBucket *alertBucket = (MemBucket *)data;
@@ -2547,7 +2559,13 @@ void DecodeIP(const uint8_t * pkt, const uint32_t len, Packet * p)
                 //ClearDumpBuf();
                 return;
 
-#ifdef GRE
+            case IPPROTO_SCTP:
+                pc.sctp++;
+                DecodeSCTP(pkt + hlen, ip_len, p);
+                //ClearDumpBuf();
+                return;
+
+ #ifdef GRE
             case IPPROTO_IPV6:
                 if (ip_len < 40)
                 {
@@ -2946,6 +2964,15 @@ void DecodeICMPEmbeddedIP(const uint8_t *pkt, const uint32_t len, Packet *p)
 
             break;
 
+        case IPPROTO_SCTP:
+            p->orig_sctph = (SCTPHdr *)(pkt + hlen);
+
+            /* stuff more data into the printout data struct */
+            p->orig_sp = ntohs(p->orig_sctph->sh_sport);
+            p->orig_dp = ntohs(p->orig_sctph->sh_dport);
+
+            break;
+
         case IPPROTO_ICMP:
             p->orig_icmph = (ICMPHdr *)(pkt + hlen);
             break;
@@ -2955,6 +2982,679 @@ void DecodeICMPEmbeddedIP(const uint8_t *pkt, const uint32_t len, Packet *p)
 }
 
 /*
+ * Function: SctpCrc32Chksum(const unsigned char* buf, unsigned int len)
+ *
+ * Purpose: Calculate the SCTP checksum using CRC32 (per RFC3309).
+ *
+ * Arguments: buf => ptr to the SCTP packet
+ *            len => length from here to the end of the packet
+ *
+ * Returns: uint32_t checksum value (CRC32)
+ */
+uint32_t SctpCrc32Chksum(const unsigned char* buf, unsigned int len)
+{
+  uint16_t i;
+  uint32_t crc32 = CRC32C_PRELOAD, result;
+
+  /* Checksum the common header EXCEPT the checksum field */
+  for (i = 0; i < (SCTP_COMMON_HEADER_LEN - 4); i++)
+      CRC32C(crc32, buf[i]);
+
+  /* Checksum four '0' bytes as the checksum value */
+  CRC32C(crc32, 0);
+  CRC32C(crc32, 0);
+  CRC32C(crc32, 0);
+  CRC32C(crc32, 0);
+
+  /* Checksum the remainder of the packet */
+  for (i = SCTP_COMMON_HEADER_LEN; i < len; i++)
+      CRC32C(crc32, buf[i]);
+
+  result = CRC32C_SWAP(crc32);
+
+  return (~result);
+}
+
+/*
+ * Function: SctpAdler32Chksum(const unsigned char* buf, unsigned int len)
+ *
+ * Purpose: Calculate the SCTP checksum using Adler32 (per RFC2960).
+ *
+ * Arguments: buf => ptr to the SCTP packet
+ *            len => length from here to the end of the packet
+ *
+ * Returns: uint32_t checksum value (Adler32)
+ */
+static unsigned int
+SctpAdler32Chksum(const unsigned char* buf, unsigned int len)
+{
+  uint32_t result = 1L;
+
+  /* Checksum four '0' bytes as the checksum value */
+  result = update_adler32(result, buf, (SCTP_COMMON_HEADER_LEN - 4));
+
+  /* handle four 0 bytes as checksum */
+  result = update_adler32(result, (unsigned char *)"\0\0\0\0", 4);
+
+  /* Checksum the remainder of the packet */
+  result = update_adler32(result, (buf + SCTP_COMMON_HEADER_LEN),
+                          (len - SCTP_COMMON_HEADER_LEN));
+
+  return result;
+}
+
+/* SCTP-layer decoder alerts */
+static inline void SctpChunkAnomaly(Packet *p, const uint16_t length,
+    const char *debug_msg, const uint16_t de_code, char *de_str)
+{
+    DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "%s!\n", debug_msg));
+    DecoderEvent(p, de_code, de_str, 1, 1);
+    p->sctph = NULL;
+    pc.discards++;
+    pc.sctpdisc++;
+
+    return;
+}
+
+/*
+ * Used often.  Better to make it a macro.  Why a macro and not an
+ * inlined function?  Because if inline, we have to pass quite a
+ * few arguments and fuss around with snprintf().  Macros can avoid
+ * this and only needs two arguments.
+ */
+
+/* Check for a bad chunk length. */
+#define CHECK_CHUNK_LENGTH(c,s)                                                     \
+    if (clen < SCTP_##c##_C_LEN)                                                    \
+    {                                                                               \
+        SctpChunkAnomaly(p, clen, "SCTP " #c " Chunk is smaller than " #s " bytes", \
+                         DECODE_SCTP_##c##_C_BAD_LEN,                               \
+                         DECODE_SCTP_##c##_C_BAD_LEN_STR);                          \
+        break;                                                                      \
+    }
+
+/* Make sure the <CHUNKT_TYPE> chunk's flags field is 0. */
+#define CHECK_CHUNK_FLAGS_ARE_ZERO(c)                                               \
+    if (cflags > 0)                                                                 \
+    {                                                                               \
+        SctpChunkAnomaly(p, clen, "SCTP " #c " chunk flags field "                  \
+                         "is non-zero", DECODE_SCTP_##c##_C_FLAGS_NZERO,            \
+                         DECODE_SCTP_##c##_C_FLAGS_NZERO_STR);                      \
+        break;                                                                      \
+    }
+
+
+void SctpChunkTests(Packet *p, const SctpChunk *sctp_chunk)
+{
+    uint8_t ctype = sctp_chunk->type;
+    uint8_t cflags = sctp_chunk->flags;
+    uint16_t clen = ntohs(sctp_chunk->length);
+
+    /* Check for zero-length chunk (minimum should ALWAYs be 4 bytes. */
+    if (clen == 0)
+    {
+        SctpChunkAnomaly(p, clen, "SCTP Chunk Length is 0 bytes",
+                         DECODE_SCTP_CHUNK_ZERO_LENGTH,
+                         DECODE_SCTP_CHUNK_ZERO_LENGTH_STR);
+        return;
+    }
+
+	/* Depending on the chunk type, check for certain anomalies, per the RFCs. */
+    switch (ctype)
+    {
+        /* DATA Chunk */
+        case SCTP_DATA_C:
+            printf("DEBUG: Got DATA chunk!\n");
+            CHECK_CHUNK_LENGTH(DATA, SCTP_DATA_C_LEN)
+
+            /*
+             * Make sure the DATA chunk's reserved area in flags is 0.
+             * Note: this includes in the 'I' flag defined in
+             * draft-tuexen-tsvwg-sctp-sack-immediately-06, so
+             * bitwise-AND 0xf0, not 0xf8.
+             */
+            /*
+             * FIXME: Create bitfield or macros to check the DATA flags, as
+             * well any flags on the other chunks.  Not for here, of course,
+             * but for future SCTP rule options.
+             */
+            if ((cflags & 0xf0) > 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP DATA chunk flags reserved field "
+                                 "is non-zero", DECODE_SCTP_DATA_C_RSVD_NZERO,
+                                 DECODE_SCTP_DATA_C_RSVD_NZERO_STR);
+                break;
+            }
+            break;
+
+        /* INIT Chunk */
+        case SCTP_INIT_C:
+            printf("DEBUG: Got INIT chunk!\n");
+            CHECK_CHUNK_LENGTH(INIT, SCTP_INIT_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(INIT)
+
+            /*
+             * Per RFC4960:
+             *   - The initiate tag should not be 0 (error).
+             *   - For an INIT chunk, the verification tag MUST be zero.
+             *   - The value '0' cannot be used in either the # of outbound
+             *     streams or # of inbound streams fields.
+             */
+            if (ntohl(sctp_chunk->init.initiate_tag) == 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT Chunk and initiate tag is == 0",
+                                 DECODE_SCTP_INIT_C_ITAG_ZERO,
+                                 DECODE_SCTP_INIT_C_ITAG_ZERO_STR);
+                break;
+            }
+            else if (ntohl(p->sctph->sh_vtag) != 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT Chunk and verification tag is > 0",
+                                 DECODE_SCTP_INIT_C_VTAG_NZERO,
+                                 DECODE_SCTP_INIT_C_VTAG_NZERO_STR);
+                break;
+            }
+            else if (ntohs(sctp_chunk->init.num_out_streams) == 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT Chunk # of outbound streams"
+                                 "is zero", DECODE_SCTP_INIT_C_NOUTSTR_ZERO,
+                                 DECODE_SCTP_INIT_C_NOUTSTR_ZERO_STR);
+                break;
+            }
+            else if (ntohs(sctp_chunk->init.num_in_streams) == 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT Chunk # of inbound streams"
+                                 "is zero", DECODE_SCTP_INIT_C_NINSTR_ZERO,
+                                 DECODE_SCTP_INIT_C_NINSTR_ZERO_STR);
+                break;
+            }
+            break;
+
+        /* INIT ACK Chunk */
+        case SCTP_INIT_ACK_C:
+            printf("DEBUG: Got INIT_ACK chunk!\n");
+            CHECK_CHUNK_LENGTH(INIT_ACK, SCTP_INIT_ACK_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(INIT_ACK)
+
+            /*
+             * Per RFC4960:
+             *   - The initiate tag MUST NOT be 0.
+             *   - The value '0' cannot be used in either the # of outbound
+             *     streams or # of inbound streams fields.
+             */
+            if (ntohl(sctp_chunk->init_ack.initiate_tag) == 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT_ACK Chunk and initiate tag is == 0",
+                                 DECODE_SCTP_INIT_ACK_C_ITAG_ZERO,
+                                 DECODE_SCTP_INIT_ACK_C_ITAG_ZERO_STR);
+                break;
+            }
+            else if (ntohs(sctp_chunk->init_ack.num_out_streams) == 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT_ACK Chunk # of outbound streams"
+                                 "is zero", DECODE_SCTP_INIT_ACK_C_NOUTSTR_ZERO,
+                                 DECODE_SCTP_INIT_ACK_C_NOUTSTR_ZERO_STR);
+                break;
+            }
+            else if (ntohs(sctp_chunk->init_ack.num_in_streams) == 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP INIT_ACK Chunk # of inbound streams"
+                                 "is zero", DECODE_SCTP_INIT_ACK_C_NINSTR_ZERO,
+                                 DECODE_SCTP_INIT_ACK_C_NINSTR_ZERO_STR);
+                break;
+            }
+            break;
+
+        /* SACK Chunk */
+        case SCTP_SACK_C:
+            printf("DEBUG: Got SACK chunk!\n");
+            CHECK_CHUNK_LENGTH(SACK, SCTP_SACK_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(SACK)
+
+            break;
+
+        /* HEARTBEAT Chunk */
+        case SCTP_HEARTBEAT_C:
+            printf("DEBUG: Got HEARTBEAT chunk!\n");
+            CHECK_CHUNK_LENGTH(HEARTBEAT, SCTP_HEARTBEAT_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(HEARTBEAT)
+
+            break;
+
+        /* HEARTBEAT_ACK Chunk */
+        case SCTP_HEARTBEAT_ACK_C:
+            printf("DEBUG: Got HEARTBEAT_ACK chunk!\n");
+            CHECK_CHUNK_LENGTH(HEARTBEAT_ACK, SCTP_HEARTBEAT_ACK_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(HEARTBEAT_ACK)
+
+            break;
+
+        /* ABORT Chunk */
+        case SCTP_ABORT_C:
+            printf("DEBUG: Got ABORT chunk!\n");
+            CHECK_CHUNK_LENGTH(ABORT, SCTP_ABORT_C_LEN)
+
+            /* Make sure the ABORT chunk's reserved area in flags is 0. */
+            if ((cflags & 0xfe) > 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP ABORT chunk flags reserved field "
+                                 "is non-zero", DECODE_SCTP_ABORT_C_RSVD_NZERO,
+                                 DECODE_SCTP_ABORT_C_RSVD_NZERO_STR);
+                break;
+            }
+
+            /* We do not check the Cause(es). */
+            /* XXX: Yet? */
+            break;
+
+        /* SHUTDOWN Chunk */
+        case SCTP_SHUTDOWN_C:
+            printf("DEBUG: Got SHUTDOWN chunk!\n");
+            CHECK_CHUNK_LENGTH(SHUTDOWN, SCTP_SHUTDOWN_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(SHUTDOWN)
+
+            break;
+
+        /* SHUTDOWN_ACK Chunk */
+        case SCTP_SHUTDOWN_ACK_C:
+            printf("DEBUG: Got SHUTDOWN_ACK chunk!\n");
+            CHECK_CHUNK_LENGTH(SHUTDOWN_ACK, SCTP_SHUTDOWN_ACK_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(SHUTDOWN_ACK)
+
+            break;
+
+        /* ERROR Chunk */
+        case SCTP_ERROR_C:
+            printf("DEBUG: Got ERROR chunk!\n");
+            CHECK_CHUNK_LENGTH(ERROR, SCTP_ERROR_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(ERROR)
+
+            /* We do not check the Cause(es). */
+            /* XXX: Yet? */
+            break;
+
+        /* COOKIE_ECHO Chunk */
+        case SCTP_COOKIE_ECHO_C:
+            printf("DEBUG: Got COOKIE_ECHO chunk!\n");
+            CHECK_CHUNK_LENGTH(COOKIE_ECHO, SCTP_COOKIE_ECHO_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(COOKIE_ECHO)
+
+            break;
+
+        /* COOKIE_ACK Chunk */
+        case SCTP_COOKIE_ACK_C:
+            printf("DEBUG: Got COOKIE_ACK chunk!\n");
+            CHECK_CHUNK_LENGTH(COOKIE_ACK, SCTP_COOKIE_ACK_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(COOKIE_ACK)
+
+            break;
+
+        /* ECNE Chunk */
+        case SCTP_ECNE_C:
+            printf("DEBUG: Got ECNE chunk!\n");
+            CHECK_CHUNK_LENGTH(ECNE, SCTP_ECNE_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(ECNE)
+
+            break;
+
+        /* CWR Chunk */
+        case SCTP_CWR_C:
+            printf("DEBUG: Got CWR chunk!\n");
+            CHECK_CHUNK_LENGTH(CWR, SCTP_CWR_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(CWR)
+
+            break;
+
+        /* SHUTDOWN_COMPLETE Chunk */
+        case SCTP_SHUTDOWN_COMPLETE_C:
+            printf("DEBUG: Got SHUTDOWN_COMPLETE chunk!\n");
+            CHECK_CHUNK_LENGTH(SHUTDOWN_COMPLETE, SCTP_SHUTDOWN_COMPLETE_C_LEN)
+
+            /* Make sure the SHUTDOWN_COMPLETE chunk's reserved area in flags is 0. */
+            if ((cflags & 0xfe) > 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP SHUTDOWN_COMPLETE chunk flags reserved field "
+                                 "is non-zero", DECODE_SCTP_SHUTDOWN_COMPLETE_C_RSVD_NZERO,
+                                 DECODE_SCTP_SHUTDOWN_COMPLETE_C_RSVD_NZERO_STR);
+                break;
+            }
+            break;
+
+        /* AUTH Chunk */
+        case SCTP_AUTH_C:
+            printf("DEBUG: Got AUTH chunk!\n");
+            CHECK_CHUNK_LENGTH(AUTH, SCTP_AUTH_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(AUTH)
+
+            break;
+
+        /* ASCONF_ACK Chunk */
+        case SCTP_ASCONF_ACK_C:
+            printf("DEBUG: Got ASCONF_ACK chunk!\n");
+            CHECK_CHUNK_LENGTH(ASCONF_ACK, SCTP_ASCONF_ACK_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(ASCONF_ACK)
+
+            break;
+
+        /* PKTDROP Chunk */
+        case SCTP_PKTDROP_C:
+            printf("DEBUG: Got PKTDROP chunk!\n");
+            CHECK_CHUNK_LENGTH(PKTDROP, SCTP_PKTDROP_C_LEN)
+
+            /* Make sure the PKTDROP chunk's reserved area in flags is 0. */
+            if ((cflags & 0xf0) > 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP PKTDROP chunk flags reserved field "
+                                 "is non-zero", DECODE_SCTP_PKTDROP_C_FLAGS_NZERO,
+                                 DECODE_SCTP_PKTDROP_C_FLAGS_NZERO_STR);
+                break;
+            }
+            else if (ntohs(sctp_chunk->pktdrop.reserved) != 0)
+            {
+                SctpChunkAnomaly(p, clen, "SCTP PKTDROP Chunk reserved field "
+                                 "is non-zero", DECODE_SCTP_PKTDROP_C_RSVD_NZERO,
+                                 DECODE_SCTP_PKTDROP_C_RSVD_NZERO_STR);
+                break;
+            }
+            break;
+
+        /* RE-CONFIG Chunk */
+        case SCTP_RECONFIG_C:
+            printf("DEBUG: Got RE-CONFIG chunk!\n");
+            CHECK_CHUNK_LENGTH(RECONFIG, SCTP_RECONFIG_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(RECONFIG)
+
+            break;
+
+        /* PAD Chunk */
+        case SCTP_PAD_C:
+            printf("DEBUG: Got PAD chunk!\n");
+            CHECK_CHUNK_LENGTH(PAD, SCTP_PAD_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(PAD)
+
+            break;
+
+        /* FORWARD_TSN Chunk */
+        case SCTP_FORWARD_TSN_C:
+            printf("DEBUG: Got FORWARD_TSN chunk!\n");
+            CHECK_CHUNK_LENGTH(FORWARD_TSN, SCTP_FORWARD_TSN_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(FORWARD_TSN)
+
+            break;
+
+        /* ASCONF Chunk */
+        case SCTP_ASCONF_C:
+            printf("DEBUG: Got ASCONF chunk!\n");
+            CHECK_CHUNK_LENGTH(ASCONF, SCTP_ASCONF_C_LEN)
+            CHECK_CHUNK_FLAGS_ARE_ZERO(ASCONF)
+
+            break;
+
+        /* XXX: default catch-all for unknown chunk types. */
+    }
+}
+
+
+/**
+ * SctpGetNextChunk - Gets the next chunk from the packet.
+ * @c: Pointer to the current SctpChunk structure containing chunk data.
+ * @rlen: uint32_t value of the remaining payload length.
+ * @clen: uint16_t value of the current chunk's length.
+ *
+ * Returns the new remaining length in the packet and points c to the
+ * next chunk in the packet.  If there are no more chunks left, it will
+ * return 0 and c will be set to NULL.
+ */
+inline uint32_t SctpGetNextChunk(SctpChunk *c, uint32_t rlen, uint16_t clen)
+{
+    if (rlen > 0)
+    {
+        /*
+         * If remaining_len is > 0, see if it is > SCTP_MAX_PADDING_LEN.  If
+         * so, we probably have another chunk to process.  Else, force
+         * remaining_len to 0, because it is most likely padding bytes.  Per
+         * RFC4960, all SCTP chunks MUST be padded to a 4-byte boundary, but
+         * this padding value MUST NOT be included in the chunk length field
+         * AND this padding MUST NOT exceed 3 bytes.
+         */
+        if (rlen > SCTP_MAX_PADDING_LEN)
+            c = (SctpChunk *)((unsigned char *)c + clen);
+        else
+        {
+            rlen = 0;
+            c = NULL;
+        }
+    }
+    
+    return rlen;
+}
+
+
+/**
+ * SctpGetNextCause - Gets the next cause from the chunk.
+ * @c: Pointer to the current SctpCause structure containing cause data.
+ * @rclen: uint16_t value of the remaining chunk length.
+ * @clen: uint16_t value of the current cause's length.
+ *
+ * Returns the new remaining length in the chunk and points c to the
+ * next cause in the chunk.  If there are no more causes left, it will
+ * return 0 and c will be set to NULL.
+ */
+inline uint16_t SctpGetNextCause(SctpCause *c, uint16_t rclen, uint16_t clen)
+{
+    if (rclen > 0)
+    {
+        /* Same as in SctpGetNextChunk. */
+        if (rclen > SCTP_MAX_PADDING_LEN)
+            c = (SctpCause *)((unsigned char *)c + clen);
+        else
+        {
+            rclen = 0;
+            c = NULL;
+        }
+    }
+    
+    return rclen;
+}
+
+
+/**
+ * SctpGetNextParam - Gets the next parameter from the chunk.
+ * @p: Pointer to the current SctpParam structure containing param data.
+ * @rclen: uint16_t value of the remaining chunk length.
+ * @plen: uint16_t value of the current param's length.
+ *
+ * Returns the new remaining length in the chunk and points p to the
+ * next param in the chunk.  If there are no more params left, it will
+ * return 0 and p will be set to NULL.
+ */
+inline uint16_t SctpGetNextParam(SctpParam *p, uint16_t rclen, uint16_t plen)
+{
+    if (rclen > 0)
+    {
+        /* Same as in SctpGetNextChunk. */
+        if (rclen > SCTP_MAX_PADDING_LEN)
+            p = (SctpParam *)((unsigned char *)p + plen);
+        else
+        {
+            rclen = 0;
+            p = NULL;
+        }
+    }
+    
+    return rclen;
+}
+
+
+/*
+ * Function: DecodeSCTP(uint8_t *, const uint32_t, Packet *)
+ *
+ * Purpose: Decode the SCTP transport layer
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => pointer to dummy packet decode struct
+ *
+ * Returns: void function
+ */
+ void DecodeSCTP(const uint8_t * pkt, const uint32_t len, Packet * p)
+ {
+    if (len < SCTP_COMMON_HEADER_LEN)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_DECODE,
+            "Truncated SCTP common header (%d bytes)\n", len));
+
+        DecoderEvent(p, DECODE_SCTP_DGRAM_LT_SCTPHDR,
+                        DECODE_SCTP_DGRAM_LT_SCTPHDR_STR, 1, 1);
+
+        p->sctph = NULL;
+        pc.discards++;
+        pc.sctpdisc++;
+
+        return;
+    }
+
+	/* Overlay the SCTP header on top of the data. */
+    p->sctph = (SCTPHdr *) pkt;
+
+    /*
+     * Checksum code moved in front of the other decoder alerts.  If it's a
+     * bad checksum (maybe due to encrypted ESP traffic), the other alerts
+     * could be false positives.
+     */
+    if (ScSctpChecksums())
+    {
+        uint32_t csum_pkt = ntohl(p->sctph->sh_csum);
+        uint32_t csum_calc;
+        uint32_t csum_valid = 0;
+
+        /*
+         * RFC2960, SCTP's original RFC, origially used the Adler32 algorithm
+         * to generate the checksum.  However, on small packets, this was
+         * inadequate and RFC3309 updated RFC2960 to use the CRC32 algorithm
+         * for the checksum instead.  Both have now been superceded by RFC4960.
+         *
+         * Start by generating only the CRC32 checksum.  If that is invalid,
+         * then we will compute the Adler32 checksum and re-compare.
+         */
+        uint32_t csum_crc32 = SctpCrc32Chksum((unsigned char *)p->sctph, len);
+
+        if ((csum_crc32 == 0) || (csum_crc32 != csum_pkt))
+        {
+            /* Try Adler32. */
+            uint32_t csum_adler32 = SctpAdler32Chksum((unsigned char *)p->sctph, len);
+
+            if ((csum_adler32 != 0) || (csum_adler32 == csum_pkt))
+            {
+                csum_valid = 1;
+                csum_calc = csum_adler32;
+
+                DEBUG_WRAP(DebugMessage(DEBUG_DECODE,
+                    "Checksum type is Adler32!\n"));
+                
+                DecoderEvent(p, DECODE_SCTP_CSUM_IS_ADLER32,
+                                DECODE_SCTP_CSUM_IS_ADLER32_STR, 1, 1);
+            }
+        }
+        else
+        {
+            csum_valid = 1;
+            csum_calc = csum_crc32;
+        }
+
+        if (!csum_valid)
+        {
+            /*
+             * Don't drop the packet if this is encapuslated in Teredo or ESP.
+             * Just get rid of the SCTP header and stop decoding.
+             */
+            if (p->packet_flags & PKT_UNSURE_ENCAP)
+            {
+                p->sctph = NULL;
+                pc.discards++;
+                pc.sctpdisc++;
+
+                return;
+            }
+
+            p->error_flags |= PKT_ERR_CKSUM_SCTP;
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "Bad SCTP checksum\n",
+                                    "0x%x versus 0x%x\n", csum_calc,
+                                    csum_pkt););
+
+            if (ScIdsMode())
+                queueExecDrop(execSctpChksmDrop, p);
+        }
+        else
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE,"SCTP Checksum: OK\n"););
+    }
+
+    /* Fill in the printout data structs */
+    p->sp = ntohs(p->sctph->sh_sport);
+    p->dp = ntohs(p->sctph->sh_dport);
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "SCTP header starts at: %p\n", p->sctph););
+
+    PushLayer(PROTO_SCTP, p, pkt, SCTP_COMMON_HEADER_LEN);
+    p->data = (uint8_t *) (pkt + SCTP_COMMON_HEADER_LEN);
+    p->dsize = (u_short)(len - SCTP_COMMON_HEADER_LEN);
+    p->proto_bits |= PROTO_BIT__SCTP;
+
+    /* Drop packet if we ignore this port */
+    if (ScIgnoreSctpPort(p->sp) || ScIgnoreSctpPort(p->dp))
+    {
+        /* Ignore all preprocessors for this packet */
+        p->packet_flags |= PKT_IGNORE_PORT;
+        return;
+    }
+
+    /* Now we check various features of the chunks. */
+    SctpChunk *chunk_data = (SctpChunk *)p->sctph->chunks;
+    uint16_t chunk_length = 0;
+    uint32_t remaining_len = (len - SCTP_COMMON_HEADER_LEN);
+
+    /*
+     * Loop through the remainder of the SCTP payload and check all chunks for
+     * decoder anomalies, based on RFC4960's guidelines. Chunk bundling is
+     * explained in RFC4960, Section 6.10.
+     */
+    while ((chunk_data != NULL) && (remaining_len != 0))
+    {
+        SctpChunkTests(p, chunk_data);
+        chunk_length = SCTP_ADD_PADDING(ntohs(chunk_data->length));
+        
+        /*
+         * If the chunk length is somehow greater than the length of the
+         * remainder of the packet, something isn't right.  Flag a decoder
+         * alert.
+         */
+        if (remaining_len >= chunk_length)
+            remaining_len -= chunk_length;
+        else
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE,
+                "SCTP chunk length (%d bytes) is > remaining packet "
+                "length (%d bytes)\n", chunk_length, remaining_len));
+
+            DecoderEvent(p, DECODE_SCTP_CHUNK_LEN_GT_DGRAM,
+                            DECODE_SCTP_CHUNK_LEN_GT_DGRAM_STR, 1, 1);
+
+            p->sctph = NULL;
+            pc.discards++;
+            pc.sctpdisc++;
+
+            return;
+        }
+
+        /* Get the next chunk. */
+        remaining_len = SctpGetNextChunk(chunk_data, remaining_len, chunk_length);
+        
+        /* Increment the chunk count.  Used by various SCTP rule options. */
+        p->sctp_chunk_count++;
+    }
+ }
+
+/*
  * Function: DecodeIPV6(uint8_t *, uint32_t)
  *
  * Purpose: Decoding IPv6 headers
@@ -3627,6 +4327,11 @@ void DecodeIPV6Extensions(uint8_t next, const uint8_t *pkt, uint32_t len, Packet
             CheckIPv6ExtensionOrder(p);
             DecodeUDP(pkt, len, p);
             return;
+        case IPPROTO_SCTP:
+            pc.sctp6++;
+            CheckIPv6ExtensionOrder(p);
+            DecodeSCTP(pkt, len, p);
+            return;
         case IPPROTO_ICMPV6:
             pc.icmp6++;
             CheckIPv6ExtensionOrder(p);
@@ -4322,6 +5027,12 @@ void DecodeESP(const uint8_t *pkt, uint32_t len, Packet *p)
             p->packet_flags &= ~PKT_UNSURE_ENCAP;
             return;
 
+        case IPPROTO_SCTP:
+            pc.sctp++;
+            DecodeSCTP(esp_payload, len, p);
+            p->packet_flags &= ~PKT_UNSURE_ENCAP;
+            return;
+
         case IPPROTO_ICMP:
             pc.icmp++;
             DecodeICMP(esp_payload, len, p);
@@ -5095,6 +5806,9 @@ void DecodeTCP(const uint8_t * pkt, const uint32_t len, Packet * p)
             if (p->packet_flags & PKT_UNSURE_ENCAP)
             {
                 p->tcph = NULL;
+                pc.discards++;
+                pc.tdisc++;
+
                 return;
             }
 
